uniform sampler2D u_diffuse_texture;
uniform sampler2D u_sdf_texture;

uniform vec4 u_palette_info;    // x, y : per pixel uv of an atlas( pallete ) texture
                                //    z : 0 : stroke, 1: line body

varying vec2 v_sdf_uv;           
varying vec2 v_dash_uv;  
varying vec4 v_diffuse;
     
 varying vec4 v_line_info;   // x : boundary distance field value
                            // y : pixel distance
                            // z : original period
                            // w : period with width weight
                            
const float end_edge = 0.98431752549;

void main()
{
    float pattern_length = abs( ( mod( v_line_info.y, v_line_info.w ) / v_line_info.w ) * v_line_info.z );
    vec2 pattern_uv = vec2( v_dash_uv.x + pattern_length * u_palette_info.x, v_dash_uv.y );
    float pattern_weight = texture2D( u_diffuse_texture, pattern_uv ).a; 
    
    float sdf_value = texture2D( u_sdf_texture, v_sdf_uv.xy ).x;
    float alpha = 1.0 - smoothstep( v_line_info.x, end_edge, sdf_value );
    alpha *= min( 1.0, pattern_weight );
    gl_FragColor = vec4( v_diffuse.rgb, alpha * v_diffuse.a );
//    gl_FragColor = vec4( 1.0, 0.0, 0.0, 1.0 );
}
