attribute vec4 a_position;
attribute vec4 a_normal;
attribute vec4 a_line;
attribute vec4 a_pattern;

varying vec4 v_line_info;
varying vec4 v_pattern_info;

uniform mat4 u_mvp;
uniform float u_unit_pixel_distance;

void main()
{
    v_line_info = vec4( a_line.xy, a_line.z * u_unit_pixel_distance, a_position.w );
    v_pattern_info = vec4( a_pattern.xy, a_pattern.z * u_unit_pixel_distance, a_pattern.w );
    vec2 pos_xy = a_position.xy + a_normal.xy * v_line_info.z; 
    gl_Position = u_mvp * vec4( pos_xy, a_position.z, 1.0 );
}
