#version 450

precision highp float;

//varying
layout (location = 2) in vec3 v_normal;
layout (location = 3) in vec3 v_position_world;

//uniform
layout (set = 1, binding = 0) uniform Block
{
    vec4 u_diffuse_color;
    vec4 u_ambient_color;
    vec4 u_light_direction;
} block;

//out fragColor
layout (location = 0) out vec4 outFragColor;

void main()
{
    vec3 norm = normalize(v_normal);
    vec3 lightDir = normalize(block.u_light_direction.xyz - v_position_world);
    float diff = clamp(dot(v_normal, lightDir), 0.0, 1.0);
    vec3 diffuse = diff * block.u_diffuse_color.xyz;

    outFragColor = vec4(diffuse + block.u_ambient_color.xyz, block.u_ambient_color.w);
}
