#version 450

//attribute
layout (location = 0) in vec3 a_position;
layout (location = 1) in vec3 a_normal;

//varying
layout (location = 2) out vec3 v_normal;
layout (location = 3) out vec3 v_position_world;

//uniform
layout (set = 0, binding = 0) uniform Block
{
    mat4 u_mvp;
    mat4 u_m;
    mat4 u_v;
    mat4 u_r_matrix;
    vec4 u_diffuse_color;
    vec4 u_ambient_color;
    vec4 u_light_direction;
} block;


void main()
{
    gl_Position = block.u_mvp * vec4( a_position, 1.0 );
    v_position_world = (block.u_m * vec4(a_position, 1.0)).xyz;
    v_normal = mat3(block.u_r_matrix) * a_normal;
}




